/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 *	INCLUDES
 ***************************************************************************/

#include <avr/io.h>

#include "config.h"
#include "io.h"


/***************************************************************************
 *	FUNCTIONS
 ***************************************************************************/

/* ----------------------------------------------------------------------- */
void initIoPorts()
{
    /* set ports direction */
    ADDRESS_DDR = PORT_DIR_OUT;
    DATA_DDR = PORT_DIR_OUT;

    /* initialize control pins */
    /* port B */
    SET_BIT(DDRB, RAMWE, PIN_DIR_OUT);
    SET_BIT(DDRB, ADRSOE, PIN_DIR_OUT);
    SET_BIT(DDRB, DATDOE, PIN_DIR_OUT);
    SET_BIT(DDRB, DATSOE, PIN_DIR_OUT);
    SET_BIT(DDRB, ADRLOE, PIN_DIR_OUT);
    /* port D */
    SET_BIT(DDRD, RAMOE, PIN_DIR_OUT);
    SET_BIT(DDRD, LED_R, PIN_DIR_OUT);
    SET_BIT(DDRD, LED_G, PIN_DIR_OUT);
    SET_BIT(DDRD, ADRHI, PIN_DIR_OUT);
    SET_BIT(DDRD, ADRLO, PIN_DIR_OUT);
    SET_BIT(DDRD, DATDDIR, PIN_DIR_OUT);

    /* enable leds */
    SET_BIT(LED_R_PORT, LED_R, LED_R_ACT);
    SET_BIT(LED_G_PORT, LED_G, LED_G_ACT);

    /* set default outputs state - deny any operation to SRAM */
    ADDRESS = 0x00;
    DATA_OUT = 0x00;

    SET_BIT(RAMOE_PORT, RAMOE, !RAMOE_ACT);
    SET_BIT(RAMWE_PORT, RAMWE, !RAMWE_ACT);

    SET_BIT(ADRHI_PORT, ADRHI, !ADRHI_ACT);
    SET_BIT(ADRLO_PORT, ADRLO, !ADRLO_ACT);

    SET_BIT(ADRLOE_PORT, ADRLOE, !ADRLOE_ACT);
    SET_BIT(ADRSOE_PORT, ADRSOE, !ADRSOE_ACT);

    SET_BIT(DATSOE_PORT, DATSOE, !DATSOE_ACT);
    SET_BIT(DATDOE_PORT, DATDOE, !DATDOE_ACT);

    SET_BIT(DATDDIR_PORT, DATDDIR, DATDDIR_READ);

    /* prevent from activating pull-ups */
    sbi(SFIOR, PUD);
}


/* END */
